unit hostFilterU;

interface

 const FILTER_FLAG_CONNECT = $80000000;       // filter returns any combination
 const FILTER_FLAG_RECV    = $40000000;       // of these flags in dwFilterFlags
 const FILTER_FLAG_SEND    = $20000000;       // in HTTHost_filter_info (TFilterInfoCall)

 // one of these is passed to DLL's HTTHost_filter_proc in the TFilterProcParamStruc.intCallType field

 type TExtensionFilterCall = (efcAllow,       // allow or deny connection
                              efcConnect,     // connection has been established
                              efcSend,        // data is about to be sent
                              efcRecv,        // data has just been received
                              efcDisconnect); // connection is being closed

 // one of these is returned by DLL from HTTHost_filter_proc

 type TExtensionFilterResult = (efrNoComment,      // proceed as usual
                                efrAskMeLater,     // async. verification in progress, return this if the action is gonna take time
                                efrDenyEverything, // terminate connection immediately
                                efrDelaySend,      // verification cannot be done right now, wait until more data comes in, then ask again
                                efrDelayRecv,      // same for received data, wait until more data comes in, then ask again
                                efrUseAnother);    // use specified patched buffer for send/recv

 // this is a callback for filters to allocate memory for buffer replacement

 type TMallocCallback = function (const _intSize: Integer): Pointer; stdcall;
 type TLogCallback = procedure (const _pcMessage: PChar); stdcall;

 // pointer to this structure is passed to HTTHost_filter_proc

 type TFilterProcParamStruc = record
                               dwConnectionId: Cardinal;      // unique identifier for this connection
                               intCallType: Integer;          // one of TExtensionFilterCall
                               dwClientIP_n: Cardinal;        // IP address of the remote HTTP client (proxy), net format
                               dwTargetIP_n: Cardinal;        // ip of target host in HOST format, net format
                               wTargetPort_n: Integer;        // port of target host, net format
                               ptrData: Pointer;              // data for verification
                               intDataLength: Integer;        // length of data for verification
                               intAllocatedDataLength: Integer;  // length af allocated buffer >= length of data for verification
                    (* out *)  ptrAnotherData: Pointer;       // data to be used instead of the original
                    (* out *)  intAnotherDataLength: Integer; // length of substituted data
                    (* out *)  intAnotherAllocatedDataLength: Integer;  // length of buffer allocated for substituted data
                              end;

 type PFilterProcParamStruc = ^TFilterProcParamStruc;

implementation

end.
