#ifndef htthost_filter_h_included
#define htthost_filter_h_included

#define FILTER_FLAG_CONNECT 0x80000000
#define FILTER_FLAG_RECV    0x40000000
#define FILTER_FLAG_SEND    0x20000000

#define  efcAllow      0
#define  efcConnect    1
#define  efcSend       2
#define  efcRecv       3
#define  efcDisconnect 4

#define efrNoComment       0
#define efrAskMeLater      1
#define efrDenyEverything  2
#define efrDelaySend       3
#define efrDelayRecv       4
#define efrUseAnother      5

typedef char* (__stdcall *MALLOC_CALLBACK)(const long _lSize);
typedef void (__stdcall *LOG_CALLBACK)(const char *_pcMessage);

typedef struct 
{
	unsigned long ulConnectionId;
	long lCallType;
	unsigned long ulHTTPClientIP_n;
	unsigned long ulTargetIP_n;
	unsigned short wTargetPort_n;
	void *pData;
	long lDataLen;
	long lAllDataLen;
	void *pAnotherData;
	long lAnotherDataLen;
	long lAnotherAllDataLen;
} 
FILTER_PROC_PARAMS;

__declspec(dllexport) void __stdcall HTTHost_filter_init(MALLOC_CALLBACK _pfMallocCallback, LOG_CALLBACK _pfLogCallback);
__declspec(dllexport) void __stdcall HTTHost_filter_info(unsigned long *_ulFlags, char *_pcDescBuf, unsigned long _ulDescBufSize);
__declspec(dllexport) long __stdcall HTTHost_filter_proc(FILTER_PROC_PARAMS *_pstrucParams);
__declspec(dllexport) void __stdcall HTTHost_filter_done();

#endif
