#pragma once
#include "resource.h"       // main symbols
#include "HTTPortCW.h"
#include "httport.h"
#include <map>
using std::map;

class ATL_NO_VTABLE CHTTPort3 : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CHTTPort3, &CLSID_HTTPort3>,
	public IDispatchImpl<IHTTPort3, &IID_IHTTPort3, &LIBID_HTTPortCWLib, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
private:
	HRESULT HTTPORTCOMERROR(const HRetCode _hRetCode);
private:
	HMODULE h_httport_dll;  
	H_Start *h_start;
	H_Stop *h_stop;
	H_SetOption *h_setoption;
	H_CreateMapping *h_createmapping;
	H_GetListeningPort *h_getlisteningport;
	H_GetMappingStats *h_getmappingstats;
	H_GetProxyStats *h_getproxystats;
	H_DestroyMapping *h_destroymapping;
	H_ReadLog *h_readlog;
	H_ReleaseMemory *h_releasememory;
	H_CreateSocks *h_createsocks;
	H_GetSocksListeningPort *h_getsockslisteningport;
	H_DestroySocks *h_destroysocks;
	bool m_boolDLLOk;
	bool m_boolStarted;
	bool m_boolAllowLocalOnly;
	long m_lTunnelingMode;
	typedef map<long, long> PortsToIndiceMap_t;
	PortsToIndiceMap_t m_mapPortsToIndice;
public:
	CHTTPort3(): m_boolDLLOk(false), m_boolStarted(false), m_lTunnelingMode(CONN_USE_AUTO), m_boolAllowLocalOnly(true)
	{ 
	}
	DECLARE_REGISTRY_RESOURCEID(IDR_HTTPORT3)
	DECLARE_NOT_AGGREGATABLE(CHTTPort3)
	BEGIN_COM_MAP(CHTTPort3)
		COM_INTERFACE_ENTRY(IHTTPort3)
		COM_INTERFACE_ENTRY(IDispatch)
	END_COM_MAP()
	DECLARE_PROTECT_FINAL_CONSTRUCT()
	HRESULT FinalConstruct()
	{
		h_httport_dll = LoadLibrary("httport.dll");
		h_start = (H_Start *)GetProcAddress(h_httport_dll, "H_Start");
		h_stop = (H_Stop *)GetProcAddress(h_httport_dll, "H_Stop");
		h_setoption = (H_SetOption *)GetProcAddress(h_httport_dll, "H_SetOption");
		h_createmapping = (H_CreateMapping *)GetProcAddress(h_httport_dll, "H_CreateMapping");
		h_getlisteningport = (H_GetListeningPort *)GetProcAddress(h_httport_dll, "H_GetListeningPort");	
		h_getproxystats = (H_GetProxyStats *)GetProcAddress(h_httport_dll, "H_GetProxyStats");
		h_getmappingstats = (H_GetMappingStats *)GetProcAddress(h_httport_dll, "H_GetMappingStats");
		h_destroymapping = (H_DestroyMapping *)GetProcAddress(h_httport_dll, "H_DestroyMapping");
		h_readlog = (H_ReadLog *)GetProcAddress(h_httport_dll, "H_ReadLog");
		h_releasememory = (H_ReleaseMemory *)GetProcAddress(h_httport_dll, "H_ReleaseMemory");
		h_createsocks = (H_CreateSocks *)GetProcAddress(h_httport_dll, "H_CreateSocks");
		h_getsockslisteningport = (H_GetSocksListeningPort *)GetProcAddress(h_httport_dll, "H_GetSocksListeningPort");
		h_destroysocks = (H_DestroySocks *)GetProcAddress(h_httport_dll, "H_DestroySocks");
		m_boolDLLOk =	(h_start != NULL) && 
						(h_stop != NULL) && 
						(h_setoption != NULL) &&
						(h_createmapping != NULL) && 
						(h_getlisteningport != NULL) && 
						(h_getproxystats != NULL) && 
						(h_getmappingstats != NULL) && 
						(h_destroymapping != NULL) &&
						(h_readlog != NULL) &&
						(h_releasememory != NULL) &&
						(h_createsocks != NULL) &&
						(h_getsockslisteningport != NULL) &&
						(h_destroysocks != NULL);
		return S_OK;
	}
	void FinalRelease() 
	{
		if (m_boolStarted) h_stop();
		FreeLibrary(h_httport_dll);	      
	}
public:
	STDMETHOD(Start)(BSTR _bsProxyHost, BSTR _bsProxyPort, BSTR _bsProxyUsername, 
					 BSTR _bsProxyPassword, BSTR _bsUserAgent, LONG _lTunnelingMode, 
					 LONG _lBytesInURL, LONG _lAllowLocalOnly);
	STDMETHOD(Stop)(LONG* _plTunnelingMode, LONG* _plBytesInURL);
	STDMETHOD(CreateMapping)(BSTR _bsTargetHost, LONG _lTargetPort, LONG _lLocalPort, LONG* _plLocalPort);
	STDMETHOD(DestroyMapping)(LONG _lLocalPort);
	STDMETHOD(StartSocks)(LONG _lLocalPort, LONG* _plLocalPort);
	STDMETHOD(StopSocks)(void);
	STDMETHOD(ReadLog)(BSTR* _pbsLogLines);
	STDMETHOD(SetHostList)(BSTR _bsHostColonPortCrlfSeparated);
	STDMETHOD(SetHeaderFields)(BSTR _bsNameColonSpaceValueCrlfSeparated);
};

OBJECT_ENTRY_AUTO(__uuidof(HTTPort3), CHTTPort3)
