#ifndef httport_h_included
#define httport_h_included

//-------------------------------------------------------------------------------------------

#define H_SUCCESS 0

#define H_ERROR_BASE 0x10000
#define H_ERROR_WINSOCK_FAILED (H_ERROR_BASE + 0)
#define H_ERROR_ALREADY_STARTED (H_ERROR_BASE + 1)
#define H_ERROR_NOT_STARTED (H_ERROR_BASE + 2)
#define H_ERROR_NO_FREE_SLOTS (H_ERROR_BASE + 3)
#define H_ERROR_UNKNOWN_OPTION (H_ERROR_BASE + 4)
#define H_ERROR_INVALID_PARAMETER (H_ERROR_BASE + 5)
#define H_ERROR_SOCKS_ALREADY_STARTED (H_ERROR_BASE + 6)
#define H_ERROR_SOCKS_NOT_STARTED (H_ERROR_BASE + 7)

#define H_OPTION_BASE 0x20000
#define H_OPTION_HOST_LIST (H_OPTION_BASE + 0)
#define H_OPTION_USER_INFO (H_OPTION_BASE + 1)
#define H_OPTION_PROXY (H_OPTION_BASE + 2)
#define H_OPTION_DATA_OVERRIDE (H_OPTION_BASE + 3)
#define H_OPTION_HEADER_FIELDS (H_OPTION_BASE + 4)

#define CONN_USE_AUTO 0
#define CONN_USE_CONNECT 1
#define CONN_USE_REMOTE 2

//-------------------------------------------------------------------------------------------

#define HRetCode unsigned long

typedef struct
{
	long lStrucSize;
	unsigned short wLocalPort;
	char* pcRemoteHost;
	unsigned short wRemotePort;
	long lAllowLocalOnly;
	long lMode;
	long lMappingId;
}
TMappingParameters;

typedef struct
{
	long lStrucSize;
	long lConnections;
	long lKBytesTransferred;
	long lSockErrors;
	long lHostErrors;
	long lTimeoutErrors;
	long lProtocolErrors;
	long lMemoryErrors;
	long lConnectErrors;
	long lOtherErrors;
	long lFatalErrors;
}
TMappingStats;

typedef struct
{
	long lStrucSize;
	long lProxyFaults;
	long lHostFaults;
	long lCurrentMode;
	long lDataOverride;
}
TProxyStats;

//-------------------------------------------------------------------------------------------

 typedef HRetCode (__stdcall H_Start)(void);
 typedef HRetCode (__stdcall H_SetOption)(long _lOption, long _lCount, char **_ppcParams);
 typedef HRetCode (__stdcall H_CreateMapping)(TMappingParameters *_pstrucParams);
 typedef HRetCode (__stdcall H_GetListeningPort)(long _lIndex, long *_plPort);
 typedef HRetCode (__stdcall H_GetMappingStats)(long _lIndex, TMappingStats *_pstrucStats);
 typedef HRetCode (__stdcall H_GetProxyStats)(TProxyStats *_pstrucStats);
 typedef HRetCode (__stdcall H_DestroyMapping)(long _lIndex);
 typedef HRetCode (__stdcall H_Stop)(void);
 typedef HRetCode (__stdcall H_CreateSocks)(TMappingParameters *_pstrucParams);
 typedef HRetCode (__stdcall H_GetSocksListeningPort)(long *_plPort);
 typedef HRetCode (__stdcall H_DestroySocks)(void);
 typedef HRetCode (__stdcall H_ReadLog)(char** _ppcLogLines);
 typedef HRetCode (__stdcall H_ReleaseMemory)(void* _pvRaw);

//-------------------------------------------------------------------------------------------

#endif