unit requestutilitiesU;

interface

 procedure SplitBy(const Src, SubStr: String; var Dest1, Dest2: String);
 function GetHTTPErrorDescription(const _wRetCode: Word): String;

implementation

 uses SysUtils;

//------------------------------------------------------------------------------
// utility function, splits string into two

 procedure SplitBy(const Src, SubStr: String; var Dest1, Dest2: String);
 var APos: Integer;
     Temp: String;
 begin

  APos := Pos(AnsiUpperCase(Substr), AnsiUpperCase(Src));
  if APos = 0 then
  begin
   Dest1 := Src;
   Dest2 := '';
   Exit;
  end;

  Temp := Src;
  Dest1 := Trim(Copy(Temp, 1, APos-1));
  Dest2 := Trim(Copy(Temp, APos + Length(SubStr), Length(Temp) - APos - Length(SubStr) + 1));

 end;

//------------------------------------------------------------------------------
// returns properly formatted HTML error document for a given error message and code

 function GetHTTPErrorDescription(const _wRetCode: Word): String;
 begin

  if _wRetCode = 100 then Result := 'Continue' else
  if _wRetCode = 101 then Result := 'Switching Protocols' else
  if _wRetCode = 200 then Result := 'OK' else
  if _wRetCode = 201 then Result := 'Created' else
  if _wRetCode = 202 then Result := 'Accepted' else
  if _wRetCode = 203 then Result := 'Non-Authoritative Information' else
  if _wRetCode = 204 then Result := 'No Content' else
  if _wRetCode = 205 then Result := 'Reset Content' else
  if _wRetCode = 206 then Result := 'Partial Content' else
  if _wRetCode = 300 then Result := 'Multiple Choices' else
  if _wRetCode = 301 then Result := 'Moved Permanently' else
  if _wRetCode = 302 then Result := 'Found' else
  if _wRetCode = 303 then Result := 'See Other' else
  if _wRetCode = 304 then Result := 'Not Modified' else
  if _wRetCode = 305 then Result := 'Use Proxy' else
  if _wRetCode = 307 then Result := 'Temporary Redirect' else
  if _wRetCode = 400 then Result := 'Bad Request' else
  if _wRetCode = 401 then Result := 'Unauthorized' else
  if _wRetCode = 402 then Result := 'Payment Required' else
  if _wRetCode = 403 then Result := 'Forbidden' else
  if _wRetCode = 404 then Result := 'Not Found' else
  if _wRetCode = 405 then Result := 'Method Not Allowed' else
  if _wRetCode = 406 then Result := 'Not Acceptable' else
  if _wRetCode = 407 then Result := 'Proxy Authentication Required' else
  if _wRetCode = 408 then Result := 'Request Time-out' else
  if _wRetCode = 409 then Result := 'Conflict' else
  if _wRetCode = 410 then Result := 'Gone' else
  if _wRetCode = 411 then Result := 'Length Required' else
  if _wRetCode = 412 then Result := 'Precondition Failed' else
  if _wRetCode = 413 then Result := 'Request Entity Too Large' else
  if _wRetCode = 414 then Result := 'Request-URI Too Large' else
  if _wRetCode = 415 then Result := 'Unsupported Media Type' else
  if _wRetCode = 416 then Result := 'Requested range not satisfiable' else
  if _wRetCode = 417 then Result := 'Expectation Failed' else
  if _wRetCode = 500 then Result := 'Internal Server Error' else
  if _wRetCode = 501 then Result := 'Not Implemented' else
  if _wRetCode = 502 then Result := 'Bad Gateway' else
  if _wRetCode = 503 then Result := 'Service Unavailable' else
  if _wRetCode = 504 then Result := 'Gateway Time-out' else
  if _wRetCode = 505 then Result := 'HTTP Version not supported'
                     else Result := 'Unknown';

 end;

//------------------------------------------------------------------------------

end.
