unit requestwininetU;

interface

 uses WinInet;

 // this is a wrapper object for HInternet handle

 type TWinInetConnection = class
                            constructor Create(const _hInet: HInternet; const _strHostPort, _strUsername, _strPassword: String);
                            destructor Destroy; override;
                           private
                            hConn: HInternet;
                           public
                            property hConnectionHandle: HInternet read hConn;
                           end;

implementation

 uses SysUtils, requestutilitiesU;

//------------------------------------------------------------------------------
// takes inet handle, 'host:port' string, 'username' and 'pa55w0rd' strings
// creates internet connection 

 constructor TWinInetConnection.Create(const _hInet: HInternet; const _strHostPort, _strUsername, _strPassword: String);
 var strHost, strPort: String;
     wPort: Word;
 begin

  inherited Create;

  SplitBy(_strHostPort, ':', strHost, strPort);

  if strPort = '' then wPort := 80
  else
   try
    wPort := StrToInt(strPort);
   except
    wPort := 80;
   end;

  hConn := InternetConnect(_hInet,
                           PChar(strHost), wPort,
                           PChar(_strUsername), PChar(_strPassword),
                           INTERNET_SERVICE_HTTP, 0, INTERNET_NO_CALLBACK);

 end;

//------------------------------------------------------------------------------

 destructor TWinInetConnection.Destroy;
 begin
  InternetCloseHandle(hConn);
  inherited Destroy;
 end;

//------------------------------------------------------------------------------

end.
