// HTTPort version 3
// TCP/IP over HTTP tunneling client/server project
// (c) 1999-2004, Dmitry Dvoinikov

// This source code is released to public domain. It's primary goal is to
// allow customization of HTTPort, but you can use it in any way you like.
// If you use it with your own software, some credits would be nice.

// This library contains the HTTPort/HTTHost shared code for encoding URLs
// and HTTP-transferred data. By modifying this DLL you can make HTTP traffic
// mimic anything. This particular implementation is used with available HTTPort
// and both public and privileged HTTHost's, therefore modified versions you can
// only use with your own HTTHost installation. If you write a useful
// modification and wish to share it with other users, please send mail to
// httport@technetva.com.

// Note to implementers: there are two things that you have control of right now -
// the request URL and response body. This means that you have no access to the
// request body nor to the method, which is always GET. I think this leaves
// mimicing SOAP protocol out of question. This is a pity and hopefully next time
// I will expand this capability further.  

// Note to implementers: no part of this particular implementation is secure
// or even intended to be secure. It has encoding, scrambling and checksum
// and whatnot, but all this is definetely insecure. The only point where
// security is applied is beyond the scope of this plugin DLL and has to do
// with strong data encryption. This plugin deals with data already encrypted.
// Then again, keep in mind, that the encryption being used is strong, as
// in "strong algorithms", but the implementation is very simple and intended
// only to prevent proxy administrators and other eavesdroppers from reading
// the data being transferred. As described in details elsewhere, it has no
// tampering protection and no replay protection.  

library transfer;

{$R *.RES}

uses
  transferurlU in 'transferurlU.pas',
  transferhtmlU in 'transferhtmlU.pas',
  transferU in 'transferU.pas';

exports HX_GetDescription, HX_AllocateMemory, HX_ReleaseMemory,
        HX_ComposeHTTHostHTTPResponse, HX_ComposeHTTHostResponseBody,
        HX_IsValidHTTHostResponse, HX_ExtractHTTHostResponse,
        HX_EncodeURL, HX_DecodeURL;

begin
 IsMultiThread := True; // this switches heap manager to multithread-safe mode
end.
